VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5730
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9915
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5730
   ScaleWidth      =   9915
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   9390
      Top             =   5130
   End
   Begin MSComctlLib.ListView lvProcess 
      Height          =   5670
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   9855
      _ExtentX        =   17383
      _ExtentY        =   10001
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type ProcessInfo
    ProcessName As String
    ProcessID As Long
    ProcessThreads As Long
    ProcessImagePathName As String
    ProcessCommandLine As String
End Type

Private tPI() As ProcessInfo
Private lngCurPocessCount As Long
Private lngOldPocessCount As Long

Private Sub Form_Load()

    Dim xColumn As ColumnHeader
    
    Me.ScaleMode = vbPixels
    
    ' diverse Einstellungen fr die ListView
    With lvProcess
    
        .View = lvwReport
        .FullRowSelect = True
        
        Set xColumn = .ColumnHeaders.Add(, , "ExeName")
        xColumn.Width = 100
        
        Set xColumn = .ColumnHeaders.Add(, , "PID")
        xColumn.Width = 60
        xColumn.Alignment = lvwColumnRight
        
        Set xColumn = .ColumnHeaders.Add(, , "Threads")
        xColumn.Width = 60
        xColumn.Alignment = lvwColumnRight
        
        Set xColumn = .ColumnHeaders.Add(, , "ExePath")
        xColumn.Width = 200
        
        Set xColumn = .ColumnHeaders.Add(, , "CommandLine")
        xColumn.Width = 600
        
    End With
    
    ' Unser Programm bentigt Debug Privilegien um auf alle Prozesse
    ' zugreifen zu knnen
    If Not EnableDebugPrivilege Then
    
        MsgBox "DebugPrivilege konnte nicht aktiviert werden. Bei einigen " & _
            "Prozessen" & vbNewLine & "kann so der Pfad der Exe-Datei und die " & _
            "CommandLine nicht ausgelesen werden.", vbOKOnly Or vbInformation, _
            "EnableDebugPrivilege"
            
    End If
    
    ' Timer starten
    Timer1.Interval = 100
    
    Call Timer1_Timer
    
End Sub

' Basiert auf "VB 5/6-Tipp 0273: Prozessliste als Exenamen anzeigen lassen"
' auf http://www.activevb.de/tipps/vb6tipps/tipp0273.html
Private Function SnapProcessList() As Long

    Dim lngRet As Long
    Dim lngCount As Long
    Dim strProcessName As String
    Dim strImagePathName As String
    Dim hSnapShot As Long
    Dim tEI As ExeInfo
    Dim tPE32 As PROCESSENTRY32
    
    hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0&)
    
    If hSnapShot <> 0 Then
    
        tPE32.dwSize = Len(tPE32)
        
        lngRet = Process32First(hSnapShot, tPE32)
        
        Do While lngRet
        
            ReDim Preserve tPI(lngCount)
            
            ' String bei vbNullChar abtrennen
            strProcessName = Left$(tPE32.szExeFile, InStr(1, tPE32.szExeFile, _
                vbNullChar) - 1)
                
            ' Pfadnamen und CommandLine von Prozess-ID ermitteln
            tEI = GetProcessParameter(tPE32.th32ProcessID)
            
            ' Einen anderen Weg um den vollen Pfadnamen unter Windows NT
            ' basierenden Systemen
            ' auszulesen, siehe
            ' http://support.microsoft.com/support/kb/articles/Q187/9/13.asp.
            
            strImagePathName = tEI.ImagePathName
            
            ' ist ein String vorhanden
            If Len(strImagePathName) > 0 Then
            
                ' "\??\" vom String entfernen
                If Left$(strImagePathName, 4) = "\??\" Then
                
                    strImagePathName = Mid$(strImagePathName, 5)
                    
                End If
                
                ' "\SystemRoot" vom String ersetzen
                If Left$(strImagePathName, 11) = "\SystemRoot" Then
                
                    strImagePathName = Environ$("SystemRoot") & Mid$( _
                        strImagePathName, 12)
                        
                End If
                
            End If
            
            ' Daten speichern
            tPI(lngCount).ProcessName = strProcessName
            tPI(lngCount).ProcessID = tPE32.th32ProcessID
            tPI(lngCount).ProcessThreads = tPE32.cntThreads
            tPI(lngCount).ProcessImagePathName = strImagePathName
            tPI(lngCount).ProcessCommandLine = tEI.CommandLine
            
            ' Zhler erhhen
            lngCount = lngCount + 1
            
            lngRet = Process32Next(hSnapShot, tPE32)
            
        Loop
        
        Call CloseHandle(hSnapShot)
        
    End If
    
    ' Anzahl der aktuellen Prozesse zurck geben
    SnapProcessList = lngCount
    
End Function

Private Sub Timer1_Timer()

    Dim xList As ListItem
    Dim lngItem As Long
    
    ' Timer stoppen
    Timer1.Enabled = False
    
    ' Anzahl der aktuellen Prozesse
    lngCurPocessCount = SnapProcessList
    
    ' ist die Anzahl der aktuellen Prozesse <> der letzten ermittelten Anzahl
    If lngCurPocessCount <> lngOldPocessCount Then
    
        ' dann neuen Wert speichern
        lngOldPocessCount = lngCurPocessCount
        
        ' Anzahl der laufenden Prozesse anzeigen
        Me.Caption = "Prozesse: " & CStr(lngCurPocessCount)
        
        ' Inhalt vom ListView lschen
        lvProcess.ListItems.Clear
        
        ' alle aktuellen Prozesse in der ListView auflisten
        For lngItem = 0 To lngCurPocessCount - 1
        
            Set xList = lvProcess.ListItems.Add(, , tPI(lngItem).ProcessName)
            xList.SubItems(1) = CStr(tPI(lngItem).ProcessID)
            xList.SubItems(2) = CStr(tPI(lngItem).ProcessThreads)
            xList.SubItems(3) = tPI(lngItem).ProcessImagePathName
            xList.SubItems(4) = tPI(lngItem).ProcessCommandLine
            
        Next lngItem
        
    End If
    
    ' Timer starten
    Timer1.Enabled = True
    
End Sub

